
// 2004-10-17:
//   00:50 - start
//   05:12 - something work.. bug fixing...
//   09:00 - generator working.. making screenshot.. going to sleep..
//   20:00 - back to work?
//   22:25 - fyling working ...
//   01:36 - random music game :)
//   03:32 - release candidate 1 :)

#include "lib/sysmain.h"
#include "lib/brutegui.h"
#include "lib/key.h"
#include <stdio.h>
#include <stdlib.h>
#include <math.h>


void gfx_start(long f, long p, long x, long y);
void gfx_print12x16( long x0, long y0, char *str, long col, long col2 );
void gfx_drawbar( long x0, long y0, long w, long h, long c);
void gfx_drawbar50( long x0, long y0, long w, long h, long c);
void gfx_tile( long x0, long y0, tiletype *tile );
void gfx_aaline (float x1, float y1, float x2, float y2, long c );



#define PI 3.141592653589793

static _inline void fcossin (float a, float *c, float *s) {
	_asm {
		fld a
		fsincos
		mov eax, c
		fstp dword ptr [eax]
		mov eax, s
		fstp dword ptr [eax]
}	}
static _inline void ftol (float f, long *a) {
	_asm {
		mov eax, a
		fld f
		fistp dword ptr [eax]
}  }



// simple value noise:
long trseed = 1;
long trand() { return(((trseed = trseed * 214013L + 2531011L) >> 16) & 0x7fff); }

static long P[768]; // permutation table

void make_noise()
{
   long i, j, tmp;
   for(i=255; i>=0; i--) P[i] = i;
   for(i=1023; i>=0; i--) { j=trand()&255; tmp=P[0]; P[0]=P[j]; P[j]=tmp; }
   for(i=255; i>=0; i--) P[i+512] = P[i+256] = P[i];   
}

// return noise 0..255
float noise2d(float x, float y)
{
   long ix, iy, i1, i2, g[4];
   float fx, fy, f1, f2;
   ftol(x-.5,&ix);
   ftol(y-.5,&iy);
   fx = x - ix;
   fy = y - iy;
   fx = fx*fx*(3 - 2*fx);
   fy = fy*fy*(3 - 2*fy);
   ix&=255;
   iy&=255;
   i1 = P[ix] + iy;
   i2 = P[ix+1] + iy;
   g[0] = P[i1];
   g[1] = P[i2];
   g[2] = P[i1+1];
   g[3] = P[i2+1];
   f1 = g[0] + (g[1] - g[0])*fx;
   f2 = g[2] + (g[3] - g[2])*fx;   
   return f1 + (f2 - f1)*fy;
}




//typedef struct { long f, p, x, y; } tiletype;
typedef struct { long x, y; } lpoint2d;
typedef struct { float x, y; } fpoint2d;
typedef struct { long x, y, w, h; } lrect2d;

#define MAPW 1024
#define MAPH 1024
//#define MAPSTEP 128

//#define HITY 400
#define HITY 420
#define POWERUPY 128
#define WATERY 64
#define CLOUDY 0
//160

//lrect2d omap; // old map pos
lrect2d map;  // generated map area (world coords)
lpoint2d view; // left-top corner of view position (world coords)
lpoint2d oview;
fpoint2d fview;
fpoint2d fviewspd;

static long    remapcnt;
static lrect2d remap[4]; // redraw at least 2 regions

// mapbuf [0][0] = (map.x&1023, map.y&1023)
long mapbuf[MAPH][MAPW];


typedef struct {
   fpoint2d p; // position (world coords)
} playertype;

typedef struct _basetype { 
   long x, y, w;
   long flags; 
   // 1 = modified, 2 = solid, 4 = air, 8 = protective area (water?), 16 = clouds
   // 32 = powerup
   // 64 = powerup taken
   //struct _basetype *next; // next in grid
} basetype;

#define MAXLAYER1 64
//#define MAXLAYER2 2048
//#define MAXLAYER3 16384
#define MAXLAYER2 256
#define MAXLAYER3 4096 //2048
basetype layer1[MAXLAYER1];
basetype layer2[MAXLAYER2];
basetype layer3[MAXLAYER3];


#define WATERANIM 0
static float anim;

basetype *l1stack[MAXLAYER2*10];
basetype *l2stack[MAXLAYER3*10];

#define BIG_INT 0x7fffFFFF

static long earlyout;

void layers_drawdfs(long x0, long y0, long dim, basetype **l1, long l1cnt)
{   
   basetype **p1;
   long       p1cnt;
   long       dmin, x, y, d, dx, dy, flagor;
   lpoint2d   box[2],mid;

   // first call should be for a part of level! (256^2 ?)

   long i, j, k, c;

#if 1
   if (remapcnt) {
/*
      for(i=0; i<remapcnt; i++)
         if (remap[i].x+remap[i].w <= x0 ||
             remap[i].y+remap[i].h <= y0 ||
             remap[i].x >= x0+dim ||
             remap[i].y >= y0+dim)
         {
            if (i==remapcnt-1) return; // not-intersecting with any redrawing regions!
         }
         else break;
         */

      if (remap[0].x+remap[0].w <= x0 ||
          remap[0].y+remap[0].h <= y0 ||
          remap[0].x >= x0+dim ||
          remap[0].y >= y0+dim)
      {
         if (remapcnt<2) return;
         if (remap[1].x+remap[1].w <= x0 ||
             remap[1].y+remap[1].h <= y0 ||
             remap[1].x >= x0+dim ||
             remap[1].y >= y0+dim)
         {
#if WATERANIM == 1
            if (remapcnt<3) return;
            if (remap[2].x+remap[2].w <= x0 ||
                remap[2].y+remap[2].h <= y0 ||
                remap[2].x >= x0+dim ||
                remap[2].y >= y0+dim)
            {
               // not-intersecting with any redrawing regions!
               return;
            }
#else
            return;
#endif
         }
      }     
   }
#endif

   // check out p1 list:

   d = dim>>1;   
   mid.x    = x0+d;     mid.y    = y0+d;
   box[0].x = x0;       box[0].y = y0;
   box[1].x = x0+dim-1; box[1].y = y0+dim-1;   

   dmin = BIG_INT;
   flagor = 0;
   p1cnt = 0;
   p1 = l1+l1cnt;   
   for(i=0; i<l1cnt; i++)
   {
      // calc. max. distance between box and point:
      x = l1[i]->x; dx = box[((unsigned long)(x - mid.x))>>31].x - x;
      y = l1[i]->y; dy = box[((unsigned long)(y - mid.y))>>31].y - y;      
      d = dx*dx + dy*dy;
      if (d < dmin) dmin = d;
   }
   for(i=0; i<l1cnt; i++)
   {
      // calc. min. distance between box and point:
      x = l1[i]->x; if ((unsigned long)(x - x0) < (unsigned long)dim) dx = 0; else dx = (((x0-x)>>31)&(dim-1)) + x0 - x;
      y = l1[i]->y; if ((unsigned long)(y - y0) < (unsigned long)dim) dy = 0; else dy = (((y0-y)>>31)&(dim-1)) + y0 - y;
      // some nasty bit tricks (Ken S. likes them very much :)
      // note! (dim-1) is not bit mask! we are just and'ing it with 000.. or 111.. mask (depending on sign)
      d = dx*dx + dy*dy;
      if (d <= dmin) {
         flagor |= l1[i]->flags;
         p1[p1cnt++] = l1[i];
      }
   }

#if 0
   if (!(flagor&1)) {
      earlyout++;
      return; // early-out (not modified)
   }
#endif

#if 0
   //if (((flagor^(flagor>>1))&2) && ((flagor^(flagor>>2))&2)) // one-color cell
   if ((flagor&2)+((flagor>>1)&2)+((flagor>>2)&2) == 2) // one-color cell
   {
      return; // early-out
   }
#endif

   if (dim <= 1) 
   {    
      // now draw using distance bitmaps!
#if 1
      dmin = BIG_INT;
      x = x0;
      y = y0;
      for(j=i=0; i<p1cnt; i++)
      {         
         dx = p1[i]->x - x;
         dy = p1[i]->y - y;
         d = dx*dx + dy*dy;
         if (d < dmin) { dmin = d; j = i; }
      }       
      if ((p1[j]->flags&(4+16))) { // ||         
#if WATERANIM == 1
         if (y < WATERY + (sin(x*.2+anim) + sin(x*.1-anim))) { //p1[j]->y < 64) {
#else
         if (y < WATERY) {
#endif
            float fd = sqrt(d);                           
            // sky & clouds shader:
            float fx = noise2d(x*.123,y*.236);
            float fy = noise2d(y*.313,x*.236);      
            float frg = (fd*.2) + ((noise2d(x*.1+fx*.01,y*.1+fy*.01)+1)*.05);
            float fb, f;
            if (frg < 0) frg = 0; 
            fb = frg - (p1[j]->y>>2) + 0x30;
            if (fb > 255) fb = 255; 
            f = fd + (fx+fy)*.03;
            if (f < 16 && (p1[j]->flags&16)) {
               f = 1 - f*(1/16.f); f *= .5f;
               fb += (0xff - fb)*f;
               frg += (0xc0 - frg)*f;
            }           
            k = ((long)frg)*0x010100 + ((long)fb);
            mapbuf[y&(MAPH-1)][x&(MAPW-1)] = (0x402000 + k) | 0x80000000;            
         } else {
            // water shader:
            float fx = noise2d(x*.123,y*.236);
            float fy = noise2d(y*.313,x*.236);
            float fd = sqrt(d);      
            float f = (fd*.2) + ((noise2d(x*.1+fx*.01,y*.1+fy*.01)+1)*.05) + 0x20;
            f *= 1024 / (float)(y - WATERY + 1024);
            if (f < 0) f = 0; k = (long)f * 0x010101;
            mapbuf[y&(MAPH-1)][x&(MAPW-1)] = (0x002030 + k) | 0x80000000;
         }
      } else if (p1[j]->flags&8) {   
         // green-plants shader:
         float fd = sqrt(d);      
         float fx = noise2d(x*.236+fd*.13,y*.346);
         float fb = 1-fd + fx*.06 + 0x40;
         float frg = fb + (1-fd);
         if (fb < 0) fb = 0; if (frg < 0) frg = 0; 
         k = ((long)fb) + ((long)frg)*0x010100;     
         mapbuf[y&(MAPH-1)][x&(MAPW-1)] = 0x005000 + k;
         //k = (((long)fb)<<16) + ((long)frg)*0x0101;
         //mapbuf[y&(MAPH-1)][x&(MAPW-1)] = 0x505000 + k;
      } else {
         // ground shader:
         float fd = sqrt(d);      
         float fx = noise2d(x*.56,y*.56+fd*.1234);
#if 1
         float frg = (16-fd*.5);
         float fb = frg + (fx*.05);
         frg += fb + 0x40;
         if (fb < 0) fb = 0; if (frg < 0) frg = 0; 
         k = ((long)fb) + ((long)frg)*0x010100;
         mapbuf[y&(MAPH-1)][x&(MAPW-1)] = 0x100000 + k;
#else
         k = ((long)(16-fd*.5))*0x020201;
         k += ((long)(fx*.05))*0x010101;
         mapbuf[y&(MAPH-1)][x&(MAPW-1)] = 0x504000 + k;
#endif         
      }
#endif
      return;
   }
   
   dim>>=1;
   layers_drawdfs(x0,y0,dim,p1,p1cnt);
   layers_drawdfs(x0+dim,y0,dim,p1,p1cnt);
   layers_drawdfs(x0,y0+dim,dim,p1,p1cnt);
   layers_drawdfs(x0+dim,y0+dim,dim,p1,p1cnt);
}

void layer_draw(basetype *l1, long l1cnt)
{
   long i, j, dim;
   for(i=0; i<l1cnt; i++) l2stack[i] = &l1[i];   
   dim = 256;
   for(j=0; j<map.h; j+=dim)
      for(i=0; i<map.w; i+=dim)
         layers_drawdfs(map.x+i, map.y+j,dim,l2stack,l1cnt);
}


void layers_dfs(long x0, long y0, long dim, basetype **l1, long l1cnt, basetype **l2, long l2cnt)
{   
   basetype **p1;
   long       p1cnt;
   basetype **p2;
   long       p2cnt;
   long       dmin, x, y, d, dx, dy, flagor;
   lpoint2d   box[2],mid;

   // first call should be for a part of level! (256^2 ?)

   long i, j, k;

   // check out p2 list:

   p2cnt = 0;
   p2 = l2+l2cnt;
   for(i=0; i<l2cnt; i++)
      if ((unsigned long)(l2[i]->x - x0) < (unsigned long)dim &&
          (unsigned long)(l2[i]->y - y0) < (unsigned long)dim)
      {
         p2[p2cnt++] = l2[i];
      }

   //if (l2stack[0] != layer3) 
   {

      if (!p2cnt) return; // nothing to do

      if (p2cnt == 1) { // one left, we can handle it fast
         dmin = BIG_INT;
         x = p2[0]->x;
         y = p2[0]->y;
         for(j=i=0; i<l1cnt; i++)
         {         
            dx = l1[i]->x - x;
            dy = l1[i]->y - y;
            d = dx*dx + dy*dy;
            if (d < dmin) { dmin = d; j = i; }      
         }
         // inherit upper layer flags:
         //p2[0]->w = l1[j]->w;
         //if ((p2[0]->flags&14) != (l1[j]->flags&14))
         p2[0]->flags = l1[j]->flags | 1;
         return; // that's all we want, folks :)
      }

   }

   // check out p1 list:

   d = dim>>1;   
   mid.x    = x0+d;     mid.y    = y0+d;
   box[0].x = x0;       box[0].y = y0;
   box[1].x = x0+dim-1; box[1].y = y0+dim-1;   

   dmin = BIG_INT;
   flagor = 0;
   p1cnt = 0;
   p1 = l1+l1cnt;   
   for(i=0; i<l1cnt; i++)
   {
      // calc. max. distance between box and point:
      x = l1[i]->x; dx = box[((unsigned long)(x - mid.x))>>31].x - x;
      y = l1[i]->y; dy = box[((unsigned long)(y - mid.y))>>31].y - y;      
      d = dx*dx + dy*dy;
      if (d < dmin) dmin = d;
   }
   for(i=0; i<l1cnt; i++)
   {
      // calc. min. distance between box and point:
      x = l1[i]->x; if ((unsigned long)(x - x0) < (unsigned long)dim) dx = 0; else dx = (((x0-x)>>31)&(dim-1)) + x0 - x;
      y = l1[i]->y; if ((unsigned long)(y - y0) < (unsigned long)dim) dy = 0; else dy = (((y0-y)>>31)&(dim-1)) + y0 - y;
      // some nasty bit tricks (Ken S. likes them very much :)
      // note! (dim-1) is not bit mask! we are just and'ing it with 000.. or 111.. mask (depending on sign)
      d = dx*dx + dy*dy;
      if (d <= dmin) {
         flagor |= l1[i]->flags;
         p1[p1cnt++] = l1[i];
      }
   }

#if 0
   if (!(flagor&1)) {
      earlyout++;
      return; // early-out (not modified)
   }
#endif

#if 1
   //if (((flagor^(flagor>>1))&2) && ((flagor^(flagor>>2))&2)) // one-color cell
   if ((flagor&2)+((flagor>>1)&2)+((flagor>>2)&2)+((flagor>>3)&2) == 2) // one-color cell
   {      
      for(i=0; i<p2cnt; i++)
         p2[i]->flags = flagor; // any modified flag will be spreaded (OR)
      return; // early-out
   }
#endif

   //if (dim <= max(256-p2cnt*4,1)) 
   //if (dim <= 64) 
   if (dim <= 16) 
   {
      for(k=0; k<p2cnt; k++)
      {
         dmin = BIG_INT;
         x = p2[k]->x;
         y = p2[k]->y;
         for(j=i=0; i<p1cnt; i++)
         {         
            dx = p1[i]->x - x;
            dy = p1[i]->y - y;
            d = dx*dx + dy*dy;
            if (d < dmin) { dmin = d; j = i; }
         }
         // inherit upper layer flags:
         //p2[k]->w = p1[j]->w;
         //if ((p2[k]->flags&14) != (p1[j]->flags&14))
         p2[k]->flags = p1[j]->flags | 1;
      }
      return;
   }
   
   dim>>=1;
   layers_dfs(x0,y0,dim,p1,p1cnt,p2,p2cnt);
   layers_dfs(x0+dim,y0,dim,p1,p1cnt,p2,p2cnt);
   layers_dfs(x0,y0+dim,dim,p1,p1cnt,p2,p2cnt);
   layers_dfs(x0+dim,y0+dim,dim,p1,p1cnt,p2,p2cnt);
}

void layer_inherit(basetype *l1, long l1cnt, basetype *l2, long l2cnt)
{
   long i, j, dim;
   for(i=0; i<l1cnt; i++) l1stack[i] = &l1[i];
   for(i=0; i<l2cnt; i++) l2stack[i] = &l2[i];
   dim = 256;
   for(j=0; j<map.h; j+=dim)
      for(i=0; i<map.w; i+=dim)
         layers_dfs(map.x+i, map.y+j,dim,l1stack,l1cnt,l2stack,l2cnt);
}

void layers_gen()
{
   long i;
   basetype *b;   
   for(b=layer1, i=0; i<MAXLAYER1; i++, b++)
   {
      b->x = (rand()*map.w>>15) + map.x;
      b->y = (rand()*map.h>>15) + map.y;      
      b->w = 0;
      b->flags = 0;
      //b->w = (rand()&127)+64;
      switch(rand()&7) {
      case 0:          
      case 4: 
         b->flags |= 32;
      case 7:
         b->flags |= 2; break;
      case 1: 
      case 5: 
         b->flags |= 8; break;
      case 2: 
         b->flags |= 64;
      case 3:          
      case 6: 
         b->flags |= 4;
         break;
      }      
      if (b->y < CLOUDY && (b->flags&32)) { 
         b->w = b->flags;
         b->flags = 16; 
      } else if (b->y < 0) {
         b->w = b->flags;
         b->flags = 4;
      }
      b->flags |= 1;      
   }
   for(b=layer2, i=0; i<MAXLAYER2; i++, b++)
   {
      b->x = (rand()*map.w>>15) + map.x;
      b->y = (rand()*map.h>>15) + map.y;
   }
   for(b=layer3, i=0; i<MAXLAYER3; i++, b++)
   {
      b->x = (rand()*map.w>>15) + map.x;
      b->y = (rand()*map.h>>15) + map.y;
   }
   layer_inherit(layer1,MAXLAYER1,layer2,MAXLAYER2);
   layer_inherit(layer2,MAXLAYER2,layer3,MAXLAYER3);
   remapcnt = 0;
   layer_draw(layer3,MAXLAYER3);
}

void layers_update(long xdim, long ydim)
{
   long i, j, k, n, ok;
   basetype *b;  

   j = 0;
   for(b=layer1, i=MAXLAYER1-1; i>=0; i--, b++)
   {
      b->flags |= 1; // modified
      if (b->x < map.x) {
         do b->x += map.w; while(b->x < map.x);
         b->y = (rand()*map.h>>15) + map.y;
         goto checkair;
      } 
      if (b->x >= map.x + map.w) {
         do b->x -= map.w; while(b->x >= map.x + map.w);
         b->y = (rand()*map.h>>15) + map.y;
         goto checkair;
      } 
      if (b->y < map.y) {
         do b->y += map.h; while(b->y < map.y);
         b->x = (rand()*map.w>>15) + map.x;         
         goto checkair;
      }
      if (b->y >= map.y + map.h) {
         do b->y -= map.h; while(b->y >= map.y + map.h);
         b->x = (rand()*map.w>>15) + map.x;                  
         goto checkair;
      }
      b->flags &= ~1; // not-modified
      j++; // number of not-modified
      continue;
checkair:
      if (((b->flags|b->w)&128)) { if (b->w) b->w|=64; else b->flags|=64; } // respawn items
      if (b->y < 0) {
         if (!b->w) b->w = b->flags;
         if ((b->w&32) && b->y < CLOUDY) b->flags = 16 | 1;
         else b->flags = 4 | 1;         
      } else if (b->w) {
         b->flags = b->w | 1;
         b->w = 0;
      }
   }
   ok = (i!=j);

   for(k=1; k<3; k++) {
      switch(k) {
      //case 0: b=layer1; n=MAXLAYER1; break;
      case 1: b=layer2; n=MAXLAYER2; break;
      case 2: b=layer3; n=MAXLAYER3; break;
      }
      for(i=n-1; i>=0; i--, b++)
      {         
         b->flags &= ~1; // not-modified by default (octree can omit some high-dens. points)         
         //b->flags |= 1;
#if 0
         if (k==2 && (unsigned long)(b->y+16) < 32) { // && (b->flags&4)) {
            if (i&1) b->x -= 2; else b->x += 2;
         }
#endif
         if (b->x < map.x)          { do b->x += map.w; while(b->x < map.x); } // continue; }   
         else if (b->x >= map.x + map.w) { do b->x -= map.w; while(b->x >= map.x + map.w); } //continue; }
         if (b->y < map.y)          { do b->y += map.h; while(b->y < map.y); } //continue; }         
         else if (b->y >= map.y + map.h) { do b->y -= map.h; while(b->y >= map.y + map.h); } // continue; }
         //b->flags &= ~1;
      }
   }

   if (1) { //ok) {
      remapcnt = 0;
      if (oview.x > view.x) {
         remap[0].x = view.x;
         remap[0].y = view.y;
         remap[0].w = oview.x - view.x + 1;
         remap[0].h = ydim;
         remapcnt = 1;
      } else if (oview.x < view.x) {
         remap[0].x = oview.x + xdim;
         remap[0].y = view.y;
         remap[0].w = view.x - oview.x + 1;
         remap[0].h = ydim;
         remapcnt = 1;
      }
      if (oview.y > view.y) {
         remap[remapcnt].y = view.y;
         remap[remapcnt].x = view.x;
         remap[remapcnt].h = oview.y - view.y + 1;
         remap[remapcnt].w = xdim;
         remapcnt++;
      } else if (oview.y < view.y) {      
         remap[remapcnt].y = oview.y + ydim;
         remap[remapcnt].x = view.x;
         remap[remapcnt].h = view.y - oview.y + 1;
         remap[remapcnt].w = xdim;      
         remapcnt++;
      }
#if WATERANIM == 1
      if (remapcnt < 3 && view.y < 0 && view.y + ydim > 0) {
         remap[remapcnt].y = 64-2;
         remap[remapcnt].x = view.x;
         remap[remapcnt].h = 4;
         remap[remapcnt].w = xdim;
         remapcnt++;
      }
#endif
      if (!remapcnt) return;
      oview = view;

      layer_inherit(layer1,MAXLAYER1,layer2,MAXLAYER2);
      layer_inherit(layer2,MAXLAYER2,layer3,MAXLAYER3);
      //layer_inherit(layer1,MAXLAYER1,layer3,MAXLAYER3);
      layer_draw(layer3,MAXLAYER3);
   }
}

static double tim, otim, mustim, mustim2, mustimpup, introtim, foundtim;
static long mustick;
static long mus1;
static long mus2;
static long mus3;
static long mus4;
static long mus5;
static long musinwater;
static long musszsz;
static long found = 0; 
// bits:
// 1 = hihats
// 2 = hit
// 4 = cryst
// 8 = bubble1
// 16 = bubble2
// 32 = wind
// 64 = bum
// 128 = blurb
static long foundcnt;
static long win;
static long badnote;
#define MAXNOTES 5

long initapp(long argc, char **argv)
{
   prognam = "Seed";
   progresiz = 0;
   xres = 640; yres = 480; fullscreen = (argc<2); colbits = 32;

   //setacquire(0,1);

   view.x = 0;
   view.y = 0;
   map.w = MAPW;
   map.h = MAPH;
   map.x = -(map.w - xres)/2;
   map.y = -(map.h - yres)/2;
   //omap = map;

   // to makes things more difficult :)
   //view.y += MAPH; map.y += MAPH;   
   view.y -= MAPH/2; map.y -= MAPH/2;
   oview = view;
   fview.x = view.x;
   fview.y = view.y;

   fviewspd.x = 0;
   fviewspd.y = 0;

   make_noise();

#if 0
   gfx_start((long)mapbuf,MAPW*4,MAPW,MAPH);
   gfx_drawbar(0,0,MAPW/2,MAPH/2,0xff0000);
   gfx_drawbar(MAPW/2,0,MAPW/2,MAPH/2,0x00ff00);
   gfx_drawbar(0,MAPH/2,MAPW/2,MAPH/2,0x0000ff);
   gfx_drawbar(MAPW/2,MAPH/2,MAPW/2,MAPH/2,0xffff00);
#endif

   layers_gen();   
   //layers_draw();
   //memset(mapbuf,0x80,sizeof(mapbuf));
 
   
   readklock(&tim);
   mustim = tim + 1;
   mustim2 = tim + 1;
   //mustim3 = tim + trand()*4/32768.0;
   mustimpup = tim;

   introtim = tim + 6;
   foundtim = tim;

   return 0;
}

void uninitapp()
{
}

void doframe()
{
   static long ok;
   static double tim0, ltim;
   static long helidir = 0, heliup = 0; // -1 / 0 / +1
   static float helianim = 0;
   static float noteanim = 0;
   long i, j, x, y, d, dx, dy;
   float f, fmx, fmy, fmax, fdx, fdy, fx, fy, fx2, fy2;
   float fsynctics;
   long  bstatus;
   char tmp[64], tmp2[2];      

   otim = tim;
   readklock(&tim);
   fsynctics = tim - otim;

   noteanim += fsynctics;
   if (noteanim > 2*PI) noteanim -= 2*PI;

   if (tim > mustim) {
      f = 1+trand()/32768.f;
      playsound("seed_inst.wav",trand()*100>>15,f,NULL,0);
      if (trand()&1) playsound("seed_inst.wav",trand()*100>>15,f*((trand()&1)?2:1.5),NULL,0);
      mustim += .1 + trand()*2/32768.f;
   }
   if (tim > mustim2) {
      mustick++;
      if ((mustick&1)) {
         if ((trand()&1)) // && tim > mustim3)
            playsound("hitat1.wav",30+(trand()*30>>15),.5+(trand()/32768.f),NULL,0);      
         if (tim < mustimpup) {
            if (mus1 && (mustick&2)) {
               if ((trand()&3)) {
                  playsound("hitat1.wav",(mustick&4)?90:50,.3,NULL,0);
                  found |= 1;
               }
               //mustimpup = tim;
            }
            if (mus5) {               
               playsound("bubble1.wav",100,2,NULL,0);               
               //found |= 128;
               if (!badnote) {
                  badnote = 1;
                  foundtim = tim + 4;
               }
               mus5 = 0;
            }
            if (mus2 || mus4) { // && !(mustick&2)) {
               if (mus2 || !(mustick&4))
                  playsound("hit.wav",100,2+(trand()/32768.f),NULL,0);
               found |= 2;
               mus2 = 0;
               //playsound("bum.wav",(mustick&2)?100:70,1,NULL,0);
            }
            if (mus3 && (mustick&2)) {
               //playsound("ahh.wav",100,1,NULL,0);
               if (trand()&1) {
                  f = 1+(trand()/32768.f);
                  playsound("cryst.wav",100,f,NULL,0);
                  playsound("cryst.wav",100,f*((trand()&1)?1.25:1.5),NULL,0);
                  found |= 4;
               }
               //playsound("bum.wav",(mustick&2)?100:70,1,NULL,0);
               //mus3 = 0;
            }
         } else {
            mus1 = 0;
            mus2 = 0;
            mus3 = 0; 
            mus4 = 0;
         }
      } else {
         j = (view.y + yres/2 > WATERY);
         if (j != musinwater) {    
            //if ((musinwater&15)==0 || (musinwater&15)==4) 
            playsound((!j)?"bubble1.wav":"bubble2.wav",50,1,NULL,0);
            //if (!j) found |= 8; else found |= 16;
            musinwater = j;
         }
         if (fabs(fviewspd.x) > 16) { //16) {
            if (!(musszsz&7)) {
               playsound("wind1.wav",100,1.125,NULL,0);
               if (!(found&32))
                  playsound("wind1.wav",100,2,NULL,0);
               found |= 32;
            }
            //if ((musszsz&15)==8)
            //   playsound("score1.wav",70,1,NULL,0);
            musszsz++;
         } else {
            musszsz = 0;
         }
      }
      mustim2 += .125;
   }
   //if (tim > mustimpup && tim > mustim3 + 4) {
   //   mustim3 = tim + trand()*4/32768.0;
   //}   

   /*
   if (view.y + yres/2 > WATERY) {
      if (!musinwater) {
         playsound("bubblamb.wav",50,1,NULL,0);
         musinwater = 1;
      }
   }
   */



   tiletype scr, pic;
   //clearscreen(ok?0x400000:0);
   if (!startdirectdraw(&scr.f,&scr.p,&scr.x,&scr.y)) return;

   gfx_start(scr.f,scr.p,scr.x,scr.y);

#if 1

   x = map.x&(MAPW-1);
   y = map.y&(MAPH-1);   
   pic.p = MAPW*4;
   pic.f = (long)&mapbuf[y][x];
   pic.x = MAPW-x;
   pic.y = MAPH-y;
   gfx_tile(map.x-view.x,map.y-view.y,&pic);
   if (y > 0) {
      pic.f = (long)&mapbuf[0][x];
      pic.x = MAPW-x;
      pic.y = y;
      gfx_tile(map.x-view.x,map.y-view.y+MAPH-y,&pic);
   }
   if (x > 0) {
      pic.f = (long)&mapbuf[y][0];
      pic.x = x;
      pic.y = MAPH-y;
      gfx_tile(map.x-view.x+MAPW-x,map.y-view.y,&pic);
      if (y > 0) {
         pic.f = (long)&mapbuf[0][0];
         pic.x = x;
         pic.y = y;
         gfx_tile(map.x-view.x+MAPW-x,map.y-view.y+MAPH-y,&pic);
      }
   }
#endif

#if 0
   for(i=0; i<remapcnt; i++)
      //gfx_rectangle
      gfx_drawbar
      (remap[i].x - view.x, remap[i].y - view.y, 
         remap[i].w, remap[i].h, 0xff0000
         ); //,0xff0000);

#endif

#if 0
   basetype *b;  
   for(b=layer1, i=0; i<MAXLAYER1; i++, b++)    
      if (((b->flags|b->w)&64) && b->y < WATERY && b->y > WATERY-128) {
         x = b->x;
         y = b->y;
         for(j=0; j<256; j++, y++)
            if (y >= WATERY || !(mapbuf[y&(MAPH-1)][x&(MAPW-1)]&0x80000000)) break;
         //if (y < WATERY) {
            for(; j>=0; j-=4, y-=4)               
               gfx_drawbar(x-view.x-2,y-view.y-2,4,4,-1);
         //}
      }
#endif

   basetype *b;  
   for(b=layer1, i=0; i<MAXLAYER1; i++, b++)    
      if (((b->flags|b->w)&64) && b->y > POWERUPY) {
         x = b->x;
         y = b->y;         
         //gfx_drawbar(x-view.x-2,y-view.y-2,4,4,-1);
         for(j=0; j<6; j++) {
            fcossin(noteanim+j*PI*1.66,&fdy,&fdx);
            fx = x-view.x-fdx*4-fdy*0;
            fy = y-view.y-fdy*4+fdx*0;                
            gfx_aaline(fx,fy,fx+fdx*8,fy+fdy*8,j*0x10+((b->y>HITY)?0xff00a0:0xffff00));
         //gfx_aaline(fx,fy,fx+fdy*4,fy-fdx*2,-1);
         }


         if (abs(view.x + xres/2 - x) < 6 && abs(view.y + yres/2 - y) < 6) {
            b->flags = b->flags&(~64);
            if (b->w) b->w = (b->w&(~64))|128; else b->flags |= 128;    
            mustimpup = tim + 8; 
            if (b->y > HITY) {
               switch(trand()&3) {     
               case 0: mus2 = 1; break;
               case 1: mus2 = 1; break;
               case 2: mus2 = 1; break; 
               case 3: mus5 = 1; break; //fake!
               }               
               //mus2 = 1;
            } else {
               switch(trand()&3) {     
               case 0: mus1 = 1; break;
               case 1: mus1 = 1; break;            
               case 2: mus3 = 1; break;
               case 3: mus3 = 1; break;
               }
               //mus5 = 1;
            }
         }
      }

#if 0
   
   basetype *b;  
   //for(b=layer1, i=0; i<MAXLAYER1; i++, b++) 
   for(b=layer3, i=0; i<MAXLAYER3; i++, b++) 
   //for(b=layer2, i=0; i<MAXLAYER2; i++, b++)    
      //gfx_drawbar(b->x-view.x-8,b->y-view.y-8,16,16,
      //gfx_drawbar(b->x-view.x-4,b->y-view.y-4,8,8,
      gfx_drawbar(b->x-view.x-2,b->y-view.y-2,4,4,
      ((b->flags&10) && b->y > 0)?((b->flags&2)?0xff0000:0x00ff00):0x0000ff);   
      //((b->flags&10) && b->y > 0)?((b->flags&2)?0xffff00:0x409040):0x404090);   
#endif

#if 1 //heli
   if (heliup) helianim += heliup*10*fsynctics;
   x = xres/2;
   y = yres/2;
   fcossin(helidir*PI/8,&fdy,&fdx);
   if (heliup>0) {
      //fdy = -fdy;
      //fdx = -fdx;
   }

   fx2 = x + fdx*4;
   fy2 = y - fdy*4;   
   gfx_aaline(fx2,fy2,x-fdx*2,y+fdy*2,0xffa060);

   if (heliup>0) {    
      fdx = -fdx;
   }

   fy = heliup*2.5; 
   f = helianim; fx = sin(f)*6; f = cos(f);
   gfx_aaline(fx2,fy2,fx2+fx*fdy+fy*fdx,fy2+fx*fdx-fy*fdy,(f<0)?0x808080:-1);
   f = helianim+PI*1.33; fx = sin(f)*6; f = cos(f);
   gfx_aaline(fx2,fy2,fx2+fx*fdy+fy*fdx,fy2+fx*fdx-fy*fdy,(f<0)?0x808080:-1);
   f = helianim+PI*.66; fx = sin(f)*6; f = cos(f);
   gfx_aaline(fx2,fy2,fx2+fx*fdy+fy*fdx,fy2+fx*fdx-fy*fdy,(f<0)?0x808080:-1);
   
   //gfx_line(fx2,fy2,fx2+16*fdy-8*fdx,fy2+16*fdx+8*fdy,-1);

   //gfx_line(x,y,x+sin(helianim+PI)*4,y+heliup*2,-1);
   //gfx_line(x,y,x+sin(helianim+PI/2)*4,y+heliup*2,-1);
      //gfx_drawbar(scr.x/2-2,yres/2-2,4,4,-1);

#else // text cursor:
   gfx_drawbar(xres/2-2,yres/2-2,4,4,-1);
#endif

   for(i=j=0; j<32; j++) if(found&(1<<j)) i++;
   if (i!=foundcnt) {            
      foundcnt=i;    
      if (foundcnt>=MAXNOTES)
         foundtim = tim + 2;
      else
         foundtim = tim + 4;
   }
   if (foundcnt>=MAXNOTES && !win && tim > foundtim) {
      // play everything!
      mus1 = 1;
      mus2 = 1;
      mus3 = 1;
      mus4 = 1;
      mustimpup = tim + 8;          
      foundtim = tim + 8;
      win = 1;
   }

   //if (tim < foundtim && fmod(foundtim - tim,.5) <.3) 
   if (win) { //foundcnt>=MAXNOTES) {
      if (tim < foundtim) {
         sprintf(tmp,"ALL NOTES FOUND!");
         for(i=0; tmp[i]; i++) {
            f = (foundtim - tim); if (f > 3) f = 3;
            f = sin((foundtim - tim + i*.125)*2*PI)*f;
            tmp2[0] = tmp[i]; tmp2[1] = 0;
            gfx_print12x16(162+i*24,102+f*10,tmp2,0,0);
            gfx_print12x16(160+i*24,100+f*10,tmp2,0x90c0ff,0xffc090);
         }
         sprintf(tmp,"YOU WIN!");
         for(i=0; tmp[i]; i++) {
            f = (foundtim - tim); if (f > 3) f = 3;
            f = sin((foundtim - tim + i*.125)*2*PI)*f;
            tmp2[0] = tmp[i]; tmp2[1] = 0;
            gfx_print12x16(242+i*24,222+f*10,tmp2,0,0);
            gfx_print12x16(240+i*24,220+f*10,tmp2,0xffe090,0x90c0ff);
         }
      }     
   } else {      
      if (tim < foundtim) {
         if (badnote==1) {
            sprintf(tmp,"THIS PURPLE STAR WAS FAKE!");
            gfx_print12x16(172,42,tmp,0,0);
            gfx_print12x16(170,40,tmp,0xc000c0,0);   
            sprintf(tmp,"    TRY DIFFERENT ONE.");
            gfx_print12x16(172,62,tmp,0,0);
            gfx_print12x16(170,60,tmp,0xc000c0,0);   
         }
      } else if (badnote) badnote = 2;
      sprintf(tmp,"%i NOTES LEFT",MAXNOTES-foundcnt);
      gfx_print12x16(252,22,tmp,0,0);
      gfx_print12x16(250,20,tmp,0xc0c000,0);   

      if (tim < introtim) {
         static char *introtxt = "FIND ALL NOTES!";      
         for(i=0; introtxt[i]; i++) {
            f = (introtim - tim); if (f > 3) f = 3;
            f = sin((introtim - tim + i*.125)*2*PI)*f;
            tmp[0] = introtxt[i]; tmp[1] = 0;
            gfx_print12x16(162+i*24,142+f*10,tmp,0,0);
            gfx_print12x16(160+i*24,140+f*10,tmp,0xffc090,0x9090ff);
         }
         gfx_print12x16(202,402,"press ^ENTER^ to restart",0,0);
         gfx_print12x16(202,422,"  press ^ESC^ to quit",0,0);
         gfx_print12x16(200,400,"press ^ENTER^ to restart",0x808080,0xa0a0a0);
         gfx_print12x16(200,420,"  press ^ESC^ to quit",0x808080,0xa0a0a0);
      }
      //print6x8(0,0,-1,0,"%.4lf %i",ltim,earlyout);
   }


   stopdirectdraw();
   nextpage();

   // ----------- update: --------------

   readkeyboard();
   if (keystatus[1]) quitloop();
   d = 256; //2; //+8;
   //ok = 0;
   //if (keystatus[KEY_UPARROW]) { view.y-=d; map.y-=d; ok++; }
   //if (keystatus[KEY_DOWNARROW]) { view.y+=d; map.y+=d; ok++; }
   //if (keystatus[KEY_LEFTARROW]) { view.x-=d; map.x-=d; ok++; }
   //if (keystatus[KEY_RIGHTARROW]) { view.x+=d; map.x+=d; ok++; }
   dx = 0;
   dy = 0;
   if (keystatus[KEY_UPARROW]) dy-=d;
   if (keystatus[KEY_DOWNARROW]) dy+=d;
   if (keystatus[KEY_LEFTARROW]) dx-=d;
   if (keystatus[KEY_RIGHTARROW]) dx+=d;   

#if 0
   // free-camera movement
   if (dx && dy) {
      f = sqrt(2)*.5;
      fdx = dx*f;
      fdy = dy*f;
   } else {
      fdx = dx;
      fdy = dy;
   }
   readmouse(&fmx,&fmy,&bstatus);
   fmax = 32;
   if (fmx < -fmax) fmx = -fmax; else if (fmx > fmax) fmx = fmax;
   if (fmy < -fmax) fmy = -fmax; else if (fmy > fmax) fmy = fmax;
   fview.x += fmx + fdx*fsynctics;
   fview.y += fmy + fdy*fsynctics;
#else

   // helicopter:
   if (dx && dy) {
      f = sqrt(2)*.5;
      fdx = dx*f;
      fdy = dy*f;
   } else {
      fdx = dx;
      fdy = dy;
   }
  
   // friction & gravity:
   if (fview.y >= WATERY-yres/2) {
      // 2
      f = fsynctics*1.5;
      fviewspd.x -= fviewspd.x*f;
      fviewspd.y -= fviewspd.y*f;
      // 5
      fviewspd.y -= 7*fsynctics;   
   } else {
      //.5
      f = fsynctics*.35f;
      fviewspd.x -= fviewspd.x*f;
      fviewspd.y -= fviewspd.y*f;
      fviewspd.y += 10*fsynctics;   
   }   
   // accelaration:
   if (dx < 0) helidir = -1;
   else if (dx > 0) helidir = +1;
   else helidir = 0;
   if (dy < 0) heliup = -1;
   else if (dy > 0) heliup = +1;
   else heliup = 0;
   if (heliup) {
      if (fview.y >= WATERY-yres/2) {
         //.1
         f = fsynctics*.06f;
         fviewspd.x += fdx*f;
         fviewspd.y += fdy*f;
      } else {
         //.1
         f = fsynctics*.07f;
         fviewspd.x += fdx*f;
         fviewspd.y += fdy*f;
      }     
   }
   
   // move your ass:
   f = fsynctics*10;
   fview.x += fviewspd.x * f;
   fview.y += fviewspd.y * f;
#endif

   ftol(fview.x,&x); dx = x - view.x;
   ftol(fview.y,&y); dy = y - view.y;


   long playonce = 0;

   x = view.x+xres/2;
   y = view.y+yres/2;
   if ((mapbuf[y&(MAPH-1)][x&(MAPW-1)]&0x80000000)) {
      if ((mapbuf[(y+dy)&(MAPH-1)][(x)&(MAPW-1)]&0x80000000)) {
         view.y += dy; map.y += dy; y += dy; ok++;
      } else {
         fview.y = view.y;
         if (fabs(fviewspd.y) > 4) {
            playsound("bum2.wav",70,.7,NULL,0);
            found |= 64;
            playonce = 1;
         }
         fviewspd.y = 0;
      }
      if ((mapbuf[(y)&(MAPH-1)][(x+dx)&(MAPW-1)]&0x80000000)) {
         view.x += dx; map.x += dx; ok++;
      } else {
         fview.x = view.x;
         if (!playonce && fabs(fviewspd.x) > 4) {
            playsound("bum2.wav",70,.7,NULL,0);
            found |= 64;
         }
         fviewspd.x = 0;
      }
   } else {
      if (dx) { view.x += dx; map.x += dx; ok++; }
      if (dy) { view.y += dy; map.y += dy; ok++; }
   }

   /*
   if (ext_keystatus[KEY_C]) {
      found = -1;
      ext_keystatus[KEY_C] = 0;
   }
   */

   if (ext_keystatus[KEY_ENTER]) {
      // reset game:
      j = view.y + MAPH/2;
      view.y -= j; map.y -= j; ok++;
      j = view.x;
      view.x -= j; map.x -= j; ok++;      
      fview.y = view.y;
      fviewspd.x = 0;
      fviewspd.y = 0;
      introtim = tim + 7;
      found = 0;
      foundcnt = 0;
      foundtim = tim;
      badnote = 0;
      win = 0;
      ext_keystatus[KEY_ENTER] = 0;
   }

   if (ok) {
      ok = 0;
      readklock(&tim0);
      anim += .1;
      earlyout = 0;
      layers_update(scr.x,scr.y);
      readklock(&ltim); ltim-=tim0;
   }
}


//---------------------------------------------------------------------
// Rendering to 32bit frame buffer...

#include "lib\\font12x16.h"

static __int64 alphalookup[260];
static long gamma[256];
static long gfx_pitch;
static long ylookup[2048];

tiletype viewport; // current clipped viewport

void gfx_start(long f, long p, long x, long y)
{
   long i;
   if (!gfx_pitch) { // init alpha blending lut's
      __int64 q = 0; 
      for(i=0;i<257;i++) { alphalookup[i] = q; q += 0x1000100010; }
      double f = 255/pow(255,(1/2.5));
      for(i=0;i<256;i++) ftol(pow(i,(1/2.5))*f, &gamma[i]);
   }
   if (p != gfx_pitch) { 
      ylookup[0] = 0; for(i=1; i<2048; i++) ylookup[i] = ylookup[i-1] + p; 
      gfx_pitch = p;
   }
   viewport.f = f;
   viewport.p = p;
   viewport.x = x;
   viewport.y = y;   
}

// ^ is a special char (toggle color)
void gfx_print12x16( long x0, long y0, char *str, long col, long col2 )
{
   // hei=16bits=2b
   // char siz=12*2b=24b
   long y, i, fp0, fp, *c, cc;
   long bit0, bit1;

   if (y0<=-16 || y0>=viewport.y-1) return; // out of screen

   fp0 = viewport.f + y0*viewport.p + x0*4;
   for(y=0; y<16; y++, fp0+=viewport.p) {      
      if ((unsigned long)(y+y0)>=(unsigned long)(viewport.y-1)) continue; // out of screen
      // draw one line of string:      
      bit0 = 1<<y;
      bit1 = bit0<<16;
      cc = col;
      for(fp=fp0, i=0; str[i]; i++) {
         if (str[i]=='^') { cc = (cc==col2)?col:col2; continue; }
         c = (long *)((long)font12x16 + ((long)str[i])*(12*2));
         // draw one line of char (12bits):
         if (c[0]&bit0) *(long *)(fp +  0) = cc;
         if (c[0]&bit1) *(long *)(fp +  4) = cc;
         if (c[1]&bit0) *(long *)(fp +  8) = cc;
         if (c[1]&bit1) *(long *)(fp + 12) = cc;
         if (c[2]&bit0) *(long *)(fp + 16) = cc;
         if (c[2]&bit1) *(long *)(fp + 20) = cc;
         if (c[3]&bit0) *(long *)(fp + 24) = cc;
         if (c[3]&bit1) *(long *)(fp + 28) = cc;
         if (c[4]&bit0) *(long *)(fp + 32) = cc;
         if (c[4]&bit1) *(long *)(fp + 36) = cc;
         if (c[5]&bit0) *(long *)(fp + 40) = cc;
         if (c[5]&bit1) *(long *)(fp + 44) = cc;
         fp+=(12*4);
      }
   }        
}

void gfx_drawbar( long x0, long y0, long w, long h, long c)
{
   long i, j, fp;
   if (x0 < 0) { w += x0 - 0; x0 = 0; }  if (x0 + w > viewport.x-1) w = viewport.x-1 - x0;
   if (y0 < 0) { h += y0 - 0; y0 = 0; }  if (y0 + h > viewport.y-1) h = viewport.y-1 - y0;
   if (w <= 0 || h <= 0) return;

   fp = viewport.f + y0*viewport.p + x0*4;   

   for(j = h-1; j >= 0; j--, fp+=viewport.p-w*4)
      for(i = w-1; i >= 0; i--, fp+=4) *(long *)fp = c;
}

void gfx_drawbar50( long x0, long y0, long w, long h, long c)
{
   long i, j, fp;
   if (x0 < 0) { w += x0 - 0; x0 = 0; }  if (x0 + w > viewport.x-1) w = viewport.x-1 - x0;
   if (y0 < 0) { h += y0 - 0; y0 = 0; }  if (y0 + h > viewport.y-1) h = viewport.y-1 - y0;
   if (w <= 0 || h <= 0) return;

   fp = viewport.f + y0*viewport.p + x0*4;   

   c=(c&0xF8F8F8)>>3; c*=7; // c = 7/8
   for(j = h-1; j >= 0; j--, fp+=viewport.p-w*4)
      for(i = w-1; i >= 0; i--, fp+=4)
         *(long *)fp = (((*(long *)fp)&0xF8F8F8)>>3) + c;
}

void gfx_tile( long x0, long y0, tiletype *tile )
{
   long x1, y1, x2, y2;
   x1 = x0;
   y1 = y0;
   x2 = x0 + tile->x;
   y2 = y0 + tile->y;
		// clip
	if (x1 < 0) x1 = 0; if (x2 > viewport.x) x2 = viewport.x;
   if (y1 < 0) y1 = 0; if (y2 > viewport.y) y2 = viewport.y;
   if (x1 >= x2 || y1 >= y2) return;

	long tptr = tile->f + (y1 - y0)*tile->p + (x1 - x0)*4;
	long ptr = viewport.f + y1*viewport.p + x1*4;
	long w4 = (x2 - x1)*4;
	for( long h = y2 - y1; h > 0; h--, ptr += viewport.p - w4, tptr += tile->p - w4) {
		for( long w = x2 - x1; w > 0; w--, ptr += 4, tptr += 4) {
			*(long *)ptr = *(long *)tptr;
		}
	}
}

inline void _alphapixel( long _ptr, long col, long a )
{	
	_asm
	{
		;mm0 = (mm1-mm0)*a + mm0
      mov eax, a
      lea eax, [gamma + eax*4]
      mov edx, [eax]
      ;mov edx, a         ;alphalookup[i] = i*0x001000100010;
		mov eax, _ptr
		movd mm0, [eax]    ;mm0: [00000000000000000000000000000000AaaaaaaaRrrrrrrrGgggggggBbbbbbbb]
		movd mm1, col      ;mm1: [00000000000000000000000000000000AaaaaaaaRrrrrrrrGgggggggBbbbbbbb]
		punpcklbw mm0, mm7 ;mm0: [00000000Aaaaaaaa00000000Rrrrrrrr00000000Gggggggg00000000Bbbbbbbb]
		punpcklbw mm1, mm7 ;mm1: [00000000Aaaaaaaa00000000Rrrrrrrr00000000Gggggggg00000000Bbbbbbbb]
		psubw mm1, mm0     ;mm1: [????????????????--------Rrrrrrrr--------Gggggggg--------Bbbbbbbb]
		psllw mm1, 4       ;mm1: [????????????????----Rrrrrrrr0000----Gggggggg0000----Bbbbbbbb0000]		
		pmulhw mm1, alphalookup[edx*8]
		paddw mm0, mm1
		packuswb mm0, mm0
		movd [eax], mm0
	}	
}

void gfx_aaline (float x1, float y1, float x2, float y2, long c )
{
   float dx, dy;
   long ptr2, ptr, i, ie, ps, pe, d, dinc, d2, d3;
   dx = x2 - x1; 
   dy = y2 - y1;
   if (dy == 0 && dx == 0) return;
      // clip (copied from Ken's code):
	if (x1 >= viewport.x) { if (x2 >= viewport.x) return; y1 += (viewport.x-x1)*dy/dx; x1 = viewport.x; }
	else if (x1 < 0) { if (x2 < 0) return; y1 += (0-x1)*dy/dx; x1 = 0; }
	if (x2 >= viewport.x) { y2 += (viewport.x-x2)*dy/dx; x2 = viewport.x; }
	else if (x2 < 0) { y2 += (0-x2)*dy/dx; x2 = 0; }
	if (y1 >= viewport.y) { if (y2 >= viewport.y) return; x1 += (viewport.y-y1)*dx/dy; y1 = viewport.y; }
	else if (y1 < 0) { if (y2 < 0) return; x1 += (0-y1)*dx/dy; y1 = 0; }
	if (y2 >= viewport.y) { x2 += (viewport.y-y2)*dx/dy; y2 = viewport.y; }
	else if (y2 < 0) { x2 += (0-y2)*dx/dy; y2 = 0; }
   
   if (fabs(dy) < fabs(dx)) {
      ftol(dy/dx*65536.0f, &dinc);
      if (x1 < x2) { ftol(x1*256.0f, &ps); ftol(x2*256.0f, &pe); ftol((y1-.5f)*65536.0f, &d); }
      else         { ftol(x2*256.0f, &ps); ftol(x1*256.0f, &pe); ftol((y2-.5f)*65536.0f, &d); }
      d += (128 - (ps&255))*dinc>>8;
      i = (ps>>8); ie = (pe>>8);
      // end point 1:
      d2 = (d&65535)>>8;
      if (i == ie) d3 = pe - ps; else d3 = 256 - (ps&255);
      ptr = viewport.f + (i<<2) + ylookup[d>>16];
      _alphapixel(ptr, c, (255-d2)*d3>>8);
      _alphapixel(ptr+viewport.p, c, d2*d3>>8);
      // line:
      i++; d+=dinc;
      for(; i<ie; i++, d+=dinc) {
         d2 = (d&65535)>>8;
         ptr = viewport.f + (i<<2) + ylookup[d>>16];
         _alphapixel(ptr, c, 255-d2);
         _alphapixel(ptr+viewport.p, c, d2);
      }
      // end point 2:
      if (i == ie) {
         d2 = (d&65535)>>8;
         ptr = viewport.f + (i<<2) + ylookup[d>>16];
         _alphapixel(ptr, c, (255-d2)*(pe&255)>>8);
         _alphapixel(ptr+viewport.p, c, d2*(pe&255)>>8);
      }
   } else {
      ftol(dx/dy*65536.0f, &dinc);
      if (y1 < y2) { ftol(y1*256.0f, &ps); ftol(y2*256.0f, &pe); ftol((x1-.5f)*65536.0f, &d); }
      else         { ftol(y2*256.0f, &ps); ftol(y1*256.0f, &pe); ftol((x2-.5f)*65536.0f, &d); }
      d += (128 - (ps&255))*dinc>>8;
      i = (ps>>8); ie = (pe>>8);
      // end point 1:
      d2 = (d&65535)>>8;
      if (i == ie) d3 = pe - ps; else d3 = 256 - (ps&255);
      ptr2 = viewport.f + ylookup[i];
      ptr = ptr2 + ((d>>14)&~3);
      _alphapixel(ptr, c, (255-d2)*d3>>8);
      _alphapixel(ptr+4, c, d2*d3>>8);
      // line:
      i++; d+=dinc; ptr2+=viewport.p;
      for(; i<ie; i++, d+=dinc, ptr2+=viewport.p) {
         d2 = (d&65535)>>8;
         ptr = ptr2 + ((d>>14)&~3);
         _alphapixel(ptr, c, 255-d2);
         _alphapixel(ptr+4, c, d2);
      }
      // end point 2:
      if (i == ie) {
         d2 = (d&65535)>>8;
         ptr = ptr2 + ((d>>14)&~3);
         _alphapixel(ptr, c, (255-d2)*(pe&255)>>8);
         _alphapixel(ptr+4, c, d2*(pe&255)>>8);
      }
   }
   __asm emms;
}


